Index: issm/trunk/src/m/classes/constants.m
===================================================================
--- issm/trunk/src/m/classes/constants.m	(revision 25994)
+++ issm/trunk/src/m/classes/constants.m	(revision 26744)
@@ -6,8 +6,9 @@
 classdef constants
 	properties (SetAccess=public) 
-		g                    = 0.;
-		omega                = 0.;
-		yts                  = 0.;
-		referencetemperature = 0.;
+		g                      = 0.;
+		omega                  = 0.;
+		yts                    = 0.;
+		referencetemperature   = 0.;
+		gravitational_constant = 0.;
 	end
 	methods
@@ -33,4 +34,7 @@
 			%the reference temperature for enthalpy model (cf Aschwanden)
 			self.referencetemperature=223.15;
+		
+			%gravitational constant: 
+			self.gravitational_constant = 6.67259e-11;
 
 		end % }}}
@@ -41,4 +45,5 @@
 			md = checkfield(md,'fieldname','constants.yts','>',0,'size',[1 1]);
 			md = checkfield(md,'fieldname','constants.referencetemperature','size',[1 1]);
+			md = checkfield(md,'fieldname','constants.gravitational_constant','size',[1 1]);
 
 		end % }}}
@@ -50,4 +55,5 @@
 			fielddisplay(self,'yts','number of seconds in a year [s/yr]');
 			fielddisplay(self,'referencetemperature','reference temperature used in the enthalpy model [K]');
+			fielddisplay(self,'gravitational_constant','Newtonian constant of gravitation [m^3/kg/s^2]');
 
 		end % }}}
@@ -56,4 +62,5 @@
 			WriteData(fid,prefix,'object',self,'fieldname','yts','format','Double');
 			WriteData(fid,prefix,'object',self,'fieldname','referencetemperature','format','Double');
+			WriteData(fid,prefix,'object',self,'fieldname','gravitational_constant','format','Double');
 		end % }}}
 		function savemodeljs(self,fid,modelname) % {{{
@@ -63,4 +70,5 @@
 			writejsdouble(fid,[modelname '.constants.yts'],self.yts);
 			writejsdouble(fid,[modelname '.constants.referencetemperature'],self.referencetemperature);
+			writejsdouble(fid,[modelname '.constants.gravitational_constant'],self.gravitational_constant);
 
 		end % }}}
Index: issm/trunk/src/m/classes/constants.py
===================================================================
--- issm/trunk/src/m/classes/constants.py	(revision 25994)
+++ issm/trunk/src/m/classes/constants.py	(revision 26744)
@@ -1,10 +1,9 @@
+from checkfield import checkfield
 from fielddisplay import fielddisplay
-from checkfield import checkfield
 from WriteData import WriteData
 
 
 class constants(object):
-    """
-    CONSTANTS class definition
+    """CONSTANTS class definition
 
        Usage:
@@ -13,52 +12,53 @@
 
     def __init__(self):  # {{{
-        self.g = 0.
-        self.omega = 0.
-        self.yts = 0.
-        self.referencetemperature = 0.
+        self.g                      = 0.
+        self.omega                  = 0.
+        self.yts                    = 0.
+        self.referencetemperature   = 0.
+        self.gravitational_constant = 0.;
 
-    #set defaults
+        #set defaults
         self.setdefaultparameters()
-
     #}}}
     def __repr__(self):  # {{{
-        string = "   constants parameters:"
-
-        string = "%s\n%s" % (string, fielddisplay(self, "g", "gravitational acceleration [m / s^2]"))
-        string = "%s\n%s" % (string, fielddisplay(self, "omega", "angular velocity of Earth [rad / s]"))
-        string = "%s\n%s" % (string, fielddisplay(self, "yts", "number of seconds in a year [s / yr]"))
-        string = "%s\n%s" % (string, fielddisplay(self, "referencetemperature", "reference temperature used in the enthalpy model [K]"))
-
-        return string
+        s = '   constants parameters:\n'
+        s += '{}\n'.format(fielddisplay(self, 'g', 'gravitational acceleration [m/s^2]'))
+        s += '{}\n'.format(fielddisplay(self, 'omega', 'angular velocity of Earth [rad/s]'))
+        s += '{}\n'.format(fielddisplay(self, 'yts', 'number of seconds in a year [s/yr]'))
+        s += '{}\n'.format(fielddisplay(self, 'referencetemperature', 'reference temperature used in the enthalpy model [K]'))
+        s += '{}\n'.format(fielddisplay(self, 'gravitational_constant', 'Newtonian constant of gravitation [m^3/kg/s^2]'))
+        return s
     #}}}
-
     def setdefaultparameters(self):  # {{{
-        #acceleration due to gravity (m / s^2)
+        # Acceleration due to gravity (m / s^2)
         self.g = 9.81
 
-        #Earth's rotation speed
+        # Earth's rotation speed
         self.omega = 7.292 * 1e-5
 
-        #converstion from year to seconds
-        self.yts = 365. * 24. * 3600.
+        # Converstion from year to seconds
+        self.yts = 365.0 * 24.0 * 3600.0
 
-        #the reference temperature for enthalpy model (cf Aschwanden)
+        # The reference temperature for enthalpy model (cf Aschwanden)
         self.referencetemperature = 223.15
+
+        # Gravitational constant:
+        self.gravitational_constant = 6.67259e-11
 
         return self
     #}}}
-
     def checkconsistency(self, md, solution, analyses):  # {{{
-        md = checkfield(md, 'fieldname', 'constants.g', '>=', 0, 'size', [1])
+        md = checkfield(md, 'fieldname', 'constants.g', '>=', 0, 'size', [1]) # We allow 0 for validation tests
         md = checkfield(md, 'fieldname', 'constants.omega', '>=', 0, 'size', [1])
         md = checkfield(md, 'fieldname', 'constants.yts', '>', 0, 'size', [1])
         md = checkfield(md, 'fieldname', 'constants.referencetemperature', 'size', [1])
+        md = checkfield(md, 'fieldname', 'constants.gravitational_constant','size',[1]);
 
         return md
     # }}}
-
     def marshall(self, prefix, md, fid):  # {{{
         WriteData(fid, prefix, 'object', self, 'fieldname', 'g', 'format', 'Double')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'yts', 'format', 'Double')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'referencetemperature', 'format', 'Double')
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'gravitational_constant', 'format', 'Double');
     # }}}
Index: issm/trunk/src/m/classes/damage.js
===================================================================
--- issm/trunk/src/m/classes/damage.js	(revision 25994)
+++ issm/trunk/src/m/classes/damage.js	(revision 26744)
@@ -48,5 +48,5 @@
 			fielddisplay(this,'max_damage','maximum possible damage (0<=max_damage<1)');
 
-			fielddisplay(this,'stabilization','0: no, 1: artificial_diffusivity, 2: SUPG (not working), 4: flux corrected transport');
+			fielddisplay(this,'stabilization','0: no stabilization, 1: artificial diffusion, 2: SUPG (not working), 4: flux corrected transport');
 			fielddisplay(this,'maxiter','maximum number of non linear iterations');
 			fielddisplay(this,'elementinterp',"interpolation scheme for finite elements {'P1','P2'}");
Index: issm/trunk/src/m/classes/damage.m
===================================================================
--- issm/trunk/src/m/classes/damage.m	(revision 25994)
+++ issm/trunk/src/m/classes/damage.m	(revision 26744)
@@ -130,5 +130,5 @@
 				fielddisplay(self,'max_damage','maximum possible damage (0<=max_damage<1)');
 				
-				fielddisplay(self,'stabilization','0: no, 1: artificial_diffusivity, 2: SUPG (not working), 4: flux corrected transport');
+				fielddisplay(self,'stabilization','0: no stabilization, 1: artificial diffusion, 2: SUPG (not working), 4: flux corrected transport');
 				fielddisplay(self,'maxiter','maximum number of non linear iterations');
 				fielddisplay(self,'elementinterp','interpolation scheme for finite elements {''P1'',''P2''}');
Index: issm/trunk/src/m/classes/damage.py
===================================================================
--- issm/trunk/src/m/classes/damage.py	(revision 25994)
+++ issm/trunk/src/m/classes/damage.py	(revision 26744)
@@ -52,5 +52,5 @@
             s += "%s\n" % fielddisplay(self, "spcdamage", "damage constraints (NaN means no constraint)")
             s += "%s\n" % fielddisplay(self, "max_damage", "maximum possible damage (0 <=max_damage < 1)")
-            s += "%s\n" % fielddisplay(self, "stabilization", "0: no, 1: artificial_diffusivity, 2: SUPG (not working), 4: Flux corrected transport")
+            s += "%s\n" % fielddisplay(self, "stabilization", "0: no stabilization, 1: artificial diffusion, 2: SUPG (not working), 4: flux corrected transport")
             s += "%s\n" % fielddisplay(self, "maxiter", "maximum number of non linear iterations")
             s += "%s\n" % fielddisplay(self, "elementinterp", "interpolation scheme for finite elements [''P1'', ''P2'']")
@@ -70,7 +70,8 @@
 
     def extrude(self, md):  # {{{
-        self.D = project3d(md, 'vector', self.D, 'type', 'node')
-        self.spcdamage = project3d(md, 'vector', self.spcdamage, 'type', 'node')
-        return self
+        if self.isdamage:
+            self.D = project3d(md, 'vector', self.D, 'type', 'node')
+            self.spcdamage = project3d(md, 'vector', self.spcdamage, 'type', 'node')
+            return self
     #}}}
 
Index: issm/trunk/src/m/classes/dsl.js
===================================================================
--- issm/trunk/src/m/classes/dsl.js	(revision 25994)
+++ issm/trunk/src/m/classes/dsl.js	(revision 26744)
@@ -1,55 +1,61 @@
-//dsl Class definition
-//
-//   Usage:
-//      dsl=dsl();
+class dsl {//{{{
+	/**
+	 * DSL class definition
+	 *
+	 * Usage:
+	 *     dsl=dsl();
+	 * 
+	 * TODO:
+	 * - Implement from struct constructor (see dsl.m)?
+	 */
+	constructor() {//{{{
+		this.global_average_thermosteric_sea_level; // Corresponds to zostoga field in CMIP5 archives. Specified as a temporally variable quantity (in m)
+		this.sea_surface_height_above_geoid; // Corresponds to zos field in CMIP5 archives. Spatial average is 0. Specified as a spatio-temporally variable quantity (in m)
+		this.sea_water_pressure_at_sea_floor; // Corresponds to bpo field in CMIP5 archives. Specified as a spatio-temporally variable quantity (in m equivalent, not in Pa!)
 
-function dsl(){
-	//methods
-	this.setdefaultparameters = function(){// {{{
-		this.requested_outputs=['default'];
-	} // }}}
-	this.disp = function(){ // {{{
-		console.log(sprintf('   dsl parameters:'));
-		fielddisplay(this,'global_average_thermosteric_sea_level_change','corresponds to zostoga field in CMIP5 archives. Specified as a temporally variable global rate (mm/yr)');
-		fielddisplay(this,'sea_surface_height_change_above_geoid','corresponds to zos field in CMIP5 archives. Spatial average is 0. Specified as a spatio-temporally variable rate (mm/yr)');
-		fielddisplay(this,'sea_water_pressure_change_at_sea_floor','corresponds to bpo field in CMIP5 archives. Specified as a spatio-temporally variable rate (in Pa/yr)');
+		let nargs = arguments.length;
+		if (nargs == 0) {
+			this.setdefaultparameters();
+		} else {
+			error('constructor not supported');
+		}
+	} //}}}
 
+	setdefaultparameters() {//{{{
+		this.global_average_thermosteric_sea_level = NaN;
+		this.sea_surface_height_above_geoid = NaN;
+		this.sea_water_pressure_at_sea_floor = NaN;
+	} //}}}
 
-	} // }}}
-	this.defaultoutputs = function(){ // {{{
-		return '';
-	}//}}}
-    this.classname = function(){ // {{{
-        return "dsl";
-    } // }}}
-    this.extrude = function(md) {//{{{
-        this.sea_surface_height_change_above_geoid=project3d(md,'vector',this.sea_surface_height_change_above_geoid,'type','node');
-        this.sea_water_pressure_change_at_sea_floor=project3d(md,'vector',this.sea_water_pressure_change_at_sea_floor,'type','node');
-        return this;
-    }//}}}
-    this.checkconsistency = function(md,solution,analyses) { //{{{
+	checkconsistency(md, solution, analyses) {//{{{
+		if (!analyses.includes('SealevelchangeAnalysis') || (solution === 'TransientSolution' && !md.transient.isslc) || !md.transient.isoceantransport) {
+			return md;
+		}
 
-        if(ArrayAnyEqual(ArrayIsMember('SealevelriseAnalysis',analyses),1)){
-            checkfield(md,'fieldname','dsl.sea_surface_height_change_above_geoid','timeseries',1,'NaN',1,'Inf',1);
-            checkfield(md,'fieldname','dsl.sea_water_pressure_change_at_sea_floor','timeseries',1,'NaN',1,'Inf',1);
-        }
+		md = checkfield(md, 'fieldname', 'dsl.global_average_thermosteric_sea_level', 'NaN', 1, 'Inf', 1);
+		md = checkfield(md, 'fieldname', 'dsl.sea_surface_height_above_geoid', 'NaN', 1, 'Inf', 1, 'timeseries', 1);
+		md = checkfield(md, 'fieldname', 'dsl.sea_water_pressure_at_sea_floor', 'NaN', 1, 'Inf', 1, 'timeseries', 1);
 
-    } // }}}
-    this.marshall=function(md,prefix,fid) { //{{{
+		if (md.solidearth.settings.compute_bp_grd) {
+			md = checkfield(md, 'fieldname', 'dsl.sea_water_pressure_at_sea_floor', 'empty', 1);
+		}
 
-        var yts=md.constants.yts;
+		return md;
+	} //}}}
 
-		WriteData(fid,prefix,'name','md.dsl.model','data',1,'format','Integer');
-		WriteData(fid,prefix,'object',this,'class','dsl','fieldname','global_average_thermosteric_sea_level_change','format','DoubleMat','mattype',1,'timeserieslength',1+1,'yts',md.constants.yts,'scale',1e-3/md.constants.yts);
-			WriteData(fid,prefix,'object',this,'class','dsl','fieldname','sea_water_pressure_change_at_sea_floor','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts,'scale',1e-3/md.constants.yts);
-			WriteData(fid,prefix,'object',this,'class',dsl,'fieldname','sea_surface_height_change_above_geoid','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
-    }//}}}
-    this.fix=function() { //{{{
-    }//}}}
-	//properties 
-    // {{{
-	this.global_average_thermosteric_sea_level_change = NaN;
-	this.sea_surface_height_change_above_geoid = NaN;
-	this.sea_water_pressure_change_at_sea_floor = NaN;
-    // }}}
-}
+	disp() {//{{{
+		console.log('WARNING: dsl::disp is not yet implemented');
+	} //}}}
+
+	marshall(md, prefix, fid) {//{{{
+		WriteData(fid, prefix, 'name', 'md.dsl.model', 'data', 1, 'format', 'Integer');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'global_average_thermosteric_sea_level', 'format', 'DoubleMat', 'mattype', 2, 'timeseries', 1, 'timeserieslength', 2, 'yts', md.constants.yts); // mattype 2, because we are sending a GMSL value identical everywhere on each element
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'sea_surface_height_above_geoid', 'format', 'DoubleMat', 'mattype', 1, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', md.constants.yts); // mattype 1 because we specify DSL at vertex locations
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'sea_water_pressure_at_sea_floor', 'format', 'DoubleMat', 'mattype', 1, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', md.constants.yts); // mattype 1 because we specify bottom pressure at vertex locations
+	} //}}}
+
+	extrude(md) {//{{{
+		this.sea_surface_height_above_geoid = project3d(md, 'vector', this.sea_surface_height_above_geoid, 'type', 'node', 'layer', 1);
+		this.sea_water_pressure_at_sea_floor = project3d(md, 'vector', this.sea_water_pressure_at_sea_floor, 'type', 'node', 'layer', 1);
+	} //}}}
+} //}}}
Index: issm/trunk/src/m/classes/dsl.m
===================================================================
--- issm/trunk/src/m/classes/dsl.m	(revision 25994)
+++ issm/trunk/src/m/classes/dsl.m	(revision 26744)
@@ -7,15 +7,10 @@
 	properties (SetAccess=public) 
 
-		global_average_thermosteric_sea_level_change; %corresponds to zostoga field in CMIP5 archives. Specified as a temporally variable global rate (mm/yr)
-		sea_surface_height_change_above_geoid; %corresponds to zos field in CMIP5 archives. Spatial average is 0. Specified as a spatio-temporally variable rate (mm/yr)
-		sea_water_pressure_change_at_sea_floor; %corresponds to bpo field in CMIP5 archives. Specified as a spatio-temporally variable rate (in mm/yr equivalent, not in Pa/yr!) for each ensemble
-		compute_fingerprints; %do we use the sea water pressure change to compute fingerprints and correct sea_surface_height_change_above_geoid
+		global_average_thermosteric_sea_level; %Corresponds to zostoga field in CMIP5 archives. Specified as a temporally variable quantity (in m).
+		sea_surface_height_above_geoid; %Corresponds to zos field in CMIP5 archives. Spatial average is 0. Specified as a spatio-temporally variable quantity (in m).
+		sea_water_pressure_at_sea_floor; %Corresponds to bpo field in CMIP5 archives. Specified as a spatio-temporally variable quantity (in m equivalent, not in Pa!).
 
 	end
 	methods
-		function self = extrude(self,md) % {{{
-			self.sea_surface_height_change_above_geoid=project3d(md,'vector',self.sea_surface_height_change_above_geoid,'type','node','layer',1);
-			self.sea_water_pressure_change_at_sea_floor=project3d(md,'vector',self.sea_water_pressure_change_at_sea_floor,'type','node','layer',1);
-		end % }}}
 		function self = dsl(varargin) % {{{
 			switch nargin
@@ -30,8 +25,15 @@
 		function self = setdefaultparameters(self) % {{{
 
-			self.global_average_thermosteric_sea_level_change=0;
-			self.sea_surface_height_change_above_geoid=NaN;
-			self.sea_water_pressure_change_at_sea_floor=NaN;
-			self.compute_fingerprints=0;
+			self.global_average_thermosteric_sea_level=NaN;
+			self.sea_surface_height_above_geoid=NaN;
+			self.sea_water_pressure_at_sea_floor=NaN;
+
+		end % }}}
+		function disp(self) % {{{
+
+			disp(sprintf('   dsl parameters:'));
+			fielddisplay(self,'global_average_thermosteric_sea_level','Corresponds to zostoga field in CMIP5 archives. Specified as a temporally variable quantity (in m).');
+			fielddisplay(self,'sea_surface_height_above_geoid','Corresponds to zos field in CMIP5 archives. Spatial average is 0. Specified as a spatio-temporally variable quantity (in m).');
+			fielddisplay(self,'sea_water_pressure_at_sea_floor','Corresponds to bpo field in CMIP5 archives. Specified as a spatio-temporally variable quantity (in m equivalent, not in Pa!).');
 
 		end % }}}
@@ -39,42 +41,48 @@
 
 			%Early return
-			if ~ismember('SealevelriseAnalysis',analyses), return; end
-			if (strcmp(solution,'TransientSolution') & md.transient.isslr == 0), return; end
-			md = checkfield(md,'fieldname','dsl.global_average_thermosteric_sea_level_change','NaN',1,'Inf',1);
-			md = checkfield(md,'fieldname','dsl.sea_surface_height_change_above_geoid','NaN',1,'Inf',1,'timeseries',1);
-			md = checkfield(md,'fieldname','dsl.sea_water_pressure_change_at_sea_floor','NaN',1,'Inf',1,'timeseries',1);
-			md = checkfield(md,'fieldname','dsl.compute_fingerprints','NaN',1,'Inf',1,'values',[0,1]);
-			if self.compute_fingerprints,
-				%check geodetic flag of slr is on: 
-				if md.slr.geodetic==0,
-					error('DSL checkconsistency error message: if bottom pressure fingerprints computations are requested, slr class should have geodetic flag on');
-				end
+			if ~ismember('SealevelchangeAnalysis',analyses) | (strcmp(solution,'TransientSolution') & md.transient.isslc == 0) | (md.transient.isoceantransport==0),
+				return;
 			end
+			md = checkfield(md,'fieldname','dsl.global_average_thermosteric_sea_level','NaN',1,'Inf',1);
+			md = checkfield(md,'fieldname','dsl.sea_surface_height_above_geoid','NaN',1,'Inf',1,'timeseries',1);
+			md = checkfield(md,'fieldname','dsl.sea_water_pressure_at_sea_floor','NaN',1,'Inf',1,'timeseries',1);
+			
+			if md.solidearth.settings.compute_bp_grd==1, 
+				md = checkfield(md,'fieldname','dsl.sea_water_pressure_at_sea_floor','empty',1);
+			end
+			
+		end % }}}
+		function marshall(self,prefix,md,fid) % {{{
+			yts=md.constants.yts;
+			WriteData(fid,prefix,'name','md.dsl.model','data',1,'format','Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','global_average_thermosteric_sea_level','format','DoubleMat','mattype',2,'timeseries',1,'timeserieslength',2,'yts',yts); %mattype 2, because we are sending a GMSL value identical everywhere on each element. 
+			WriteData(fid,prefix,'object',self,'fieldname','sea_surface_height_above_geoid','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',yts); %mattype 1 because we specify DSL at vertex locations.
+			WriteData(fid,prefix,'object',self,'fieldname','sea_water_pressure_at_sea_floor','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',yts); %mattype 1 because we specify bottom pressure at vertex locations.
 
 		end % }}}
-		function disp(self) % {{{
+		function self = extrude(self,md) % {{{
+			self.sea_surface_height_above_geoid=project3d(md,'vector',self.sea_surface_height_above_geoid,'type','node','layer',1);
+			self.sea_water_pressure_at_sea_floor=project3d(md,'vector',self.sea_water_pressure_at_sea_floor,'type','node','layer',1);
+		end % }}}
+		function self = initialize(self,md) % {{{
 
-			disp(sprintf('   dsl parameters:'));
-			fielddisplay(self,'global_average_thermosteric_sea_level_change','corresponds to zostoga field in CMIP5 archives. Specified as a temporally variable global rate (mm/yr)');
-			fielddisplay(self,'sea_surface_height_change_above_geoid','corresponds to zos field in CMIP5 archives. Spatial average is 0. Specified as a spatio-temporally variable rate (mm/yr)');
-			fielddisplay(self,'sea_water_pressure_change_at_sea_floor','corresponds to bpo field in CMIP5 archives. Specified as a spatio-temporally variable rate (in Pa/yr)');
-			fielddisplay(self,'compute_fingerprints','%do we use the sea water pressure change to compute fingerprints and correct sea_surface_height_change_above_geoid');
-
-		end % }}}
-		function marshall(self,prefix,md,fid) % {{{
-
-			WriteData(fid,prefix,'name','md.dsl.model','data',1,'format','Integer');
-			WriteData(fid,prefix,'object',self,'fieldname','compute_fingerprints','format','Integer');
-			WriteData(fid,prefix,'object',self,'fieldname','global_average_thermosteric_sea_level_change','format','DoubleMat','mattype',1,'timeseries',1,'timeserieslength',2,'yts',md.constants.yts,'scale',1e-3/md.constants.yts);
-			WriteData(fid,prefix,'object',self,'fieldname','sea_water_pressure_change_at_sea_floor','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
-			WriteData(fid,prefix,'object',self,'fieldname','sea_surface_height_change_above_geoid','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
-
+			if isnan(self.global_average_thermosteric_sea_level)
+				self.global_average_thermosteric_sea_level=[0;0];
+				disp('      no dsl.global_average_thermosteric_sea_level specified: transient values set at zero');
+			end
+			if isnan(self.sea_surface_height_above_geoid)
+				self.sea_surface_height_above_geoid=[zeros(md.mesh.numberofvertices,1);0];
+				disp('      no dsl.sea_surface_height_above_geoid specified: transient values set at zero');
+			end
+			if isnan(self.sea_water_pressure_at_sea_floor)
+				self.sea_water_pressure_at_sea_floor=[zeros(md.mesh.numberofvertices,1);0];
+				disp('      no dsl.sea_water_pressure_at_sea_floor specified: transient values set at zero');
+			end
 		end % }}}
 		function savemodeljs(self,fid,modelname) % {{{
-		
-			writejs1Darray(fid,[modelname '.dsl.global_average_thermosteric_sea_level_change'],self.global_average_thermosteric_sea_level_change);
-			writejs1Darray(fid,[modelname '.dsl.compute_fingerprints'],self.compute_fingerprints);
-			writejs1Darray(fid,[modelname '.dsl.sea_surface_height_change_above_geoid'],self.sea_surface_height_change_above_geoid);
-			writejs1Darray(fid,[modelname '.dsl.sea_water_pressure_change_at_sea_floor'],self.sea_water_pressure_change_at_sea_floor);
+
+			writejs1Darray(fid,[modelname '.dsl.global_average_thermosteric_sea_level'],self.global_average_thermosteric_sea_level);
+			writejs1Darray(fid,[modelname '.dsl.sea_surface_height_above_geoid'],self.sea_surface_height_above_geoid);
+			writejs1Darray(fid,[modelname '.dsl.sea_water_pressure_at_sea_floor'],self.sea_water_pressure_at_sea_floor);
 
 		end % }}}
